var global_rtn_video = global_rtn_video || null;
var global_document_url = global_document_url || null;

function vid_mate_get_video_id(url)
{
	var vid_mate_url = url || document.URL;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}
	//http://songslelo.com/download/4069/hey_ganaraya_%28abcd_-_any_body_can_dance_2%29_hd
	if(-1 == vid_mate_url.indexOf("songslelo"))
	{
		return null;
	}

	var video_id = null;
	if(-1 != vid_mate_url.indexOf("download") )
	{
		var arr = vid_mate_url.split("/");
		if(arr.length < 5)
		{
		   return null;
		}
		
		return arr[4];
	}
}

function vid_mate_check() {
	if (vid_mate_get_video_id() == null) {
		vid_mate_set_canDownload(false);
		return false;
	} else {
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_get_video_info(url)
{
    vid_mate_setParseMsg(10, 20, 'Start Analytics');
	var vid_mate_video_id = vid_mate_get_video_id(url);
	vid_mate_setParseMsg(20, 60, 'Get Video Info');
	global_document_url = url;
	try {
		vid_mate_setParseMsg(20, 60, 'Get Video Info......');
		var referer = url;
		var cookie = "";
		if(window.vbrowser.httpGetCookie)
		{
			cookie = window.vbrowser.httpGetCookie(global_document_url);
		}
		else
		{
			cookie = document.cookie;
		}

		var userAgent = "Mozilla/5.0 (Linux; Android 4.3; Build/KRT16M) AppleWebKit/517.36 (KHTML, like Gecko) Version/4.0 Chrome/30.0.0.0 Mobile Safari/537.36";
		var method = "get";
		var data = "";
		vid_mate_app_xhr_adv(url, referer, cookie, userAgent, method, data);
	} catch (e) {
		vid_mate_error_default('songslelo 1');
		return null;
	}
}

function vid_mate_video_analytics(vm_content)
{
	if(!vm_content)
	{
		vid_mate_error_default('vm_content is empty');
		return null;
	}

	var videoUrl = "";
	var videoImg = "";
	var videoTitle = "";

	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "songslelo";
	rtn_video.id = vid_mate_get_video_id(global_document_url);
	
	if(-1 != global_document_url.indexOf("download"))
	{
		var tmp_img = cutstr(vm_content, "absmiddle\" src=\"", "\"");
		if(tmp_img)
		{
		   videoImg = "http://songslelo.com" + tmp_img;
		}
		
		var tmp_id = vid_mate_get_video_id(global_document_url);
		tmp_id = "/" + tmp_id + "\">";
		videoTitle = cutstr(vm_content, tmp_id, "</a>");
		
		var video_mp4_url = "http://songslelo.com/files/download/id/"+ vid_mate_get_video_id(global_document_url);;
		rtn_video.picture_default = videoImg;
		rtn_video.picture_big = videoImg;
		if(!videoTitle)
		{
		  videoTitle = "download video";
		}
		rtn_video.title = videoTitle;	
	    global_rtn_video = rtn_video;
		//302 handler
		try {
				window.vbrowser.httpBeginGetAll();
				var url = "http://api.apk.vidmate.net/url?url=" + video_mp4_url;
				window.vbrowser.httpAddUrl(url);
				window.vbrowser.httpGetAll('vid_mate_app_xhr_more_result()');
		}
		catch (e) {
				vid_mate_error_default('songslelo 302 request ' + e.name + ": " + e.message);
				return null;
		}
	}
	else
	{
	   vid_mate_error_default('can not find video');
	   return null;
	}

}

function vid_mate_app_xhr_more_result() {
   var rtn_contents = [];
   try {
           var tmp_count = window.vbrowser.httpGetResCount();
           for (var i = 0;i < tmp_count;i ++) {
                   var tmp_content = window.vbrowser.httpGetResAtIndex(i);
                   rtn_contents.push(tmp_content);
           }
   } catch (e) {
           vid_mate_error_default('songslelo 3\r\n' + e.name + ": " + e.message);
           return null;
   }

   vid_mate_video_analytics_more(rtn_contents);
}


function vid_mate_video_analytics_more(vm_content_array)
{
    for(var i=0; i<vm_content_array.length; ++i)
    {
       var videoUrl = vm_content_array[i];
       if(!videoUrl)
       {
               continue;
       }				
       videoUrl = decodeURIComponent(videoUrl);
       videoUrl = videoUrl.replace(/&amp;/g, "&");
       videoUrl = videoUrl.replace(/ /g, "%20");
       var tmp_video_file = new vid_mate_video_file();
       tmp_video_file.url =  videoUrl;
       var tmp_format = vid_mate_get_video_format(tmp_video_file.url);
       tmp_video_file.format = tmp_format;
       tmp_video_file.title = tmp_format;
       tmp_video_file.f_id = global_rtn_video.id + "_"+ tmp_format;
       global_rtn_video.files.push(tmp_video_file);
    }

    if(0 == global_rtn_video.files.length)
    {
	     vid_mate_error_default('songslelo length is 0');
         return null;
    }
    vid_mate_setParseMsg(100, 100, 'Completed');
    vid_mate_set_videoInfo(JSON.stringify(global_rtn_video));
}

function vid_mate_get_video_info_on_blank(url)
{
	vid_mate_get_video_info(url);
}

function rcutstr(content, prefix, suffix)
{
	var prefix_len = prefix.length;
	var p2 = content.indexOf(suffix);
	if(-1 == p2)
	{
		return "";
	}

	content = content.substr(0, p2);
	var p1 = content.lastIndexOf(prefix);
	if(-1 == p2)
	{
		return "";
	}
	return content.substring(p1 + prefix_len , p2);
}

function get_pathname(url)
{
	var arr = url.split("?");
	url = arr[0];
	arr = url.split("/");
	arr.pop();
	var pathname = "";
	var sep = "/";
	for(var i=3; i<arr.length; ++i)
	{
		pathname += sep + arr[i];
	}
	if(0 == pathname.length)
	{
		pathname = "/";
	}
	return pathname;
}

function cutstr(content, prefix, suffix)
{
	var prefix_len = prefix.length;
	var p1 = content.indexOf(prefix);
	if(-1 == p1)
	{
		return "";
	}
	p1 += prefix_len;
	var p2 = content.indexOf(suffix, p1);
	if(-1 == p2)
	{
		return "";
	}
	return content.substring(p1, p2);
}
