var global_rtn_video = global_rtn_video || null;
var global_document_url = global_document_url || null;

function vid_mate_get_video_id(url)
{
	var vid_mate_url = url || document.URL;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}

	//http://m.palcomp3.com/geraldojunior/
	if(-1 == vid_mate_url.indexOf("palcomp3"))
	{
		return null;
	}
	var arr = vid_mate_url.split("/");
	if(5 != arr.length)
	{
		return null;
	}

	return arr[3];
}

function vid_mate_check() {
	if (vid_mate_get_video_id() == null) {
		vid_mate_set_canDownload(false);
		return false;
	} else {
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_get_video_info(url)
{
    vid_mate_setParseMsg(10, 20, 'Start Analytics');

	var vid_mate_video_id = vid_mate_get_video_id(url);
	vid_mate_setParseMsg(20, 60, 'Get Video Info');

	global_document_url = url;

	url = "https://m.palcomp3.com/ajax/playlist?artista="+vid_mate_video_id+"";
	url = "http://api.test.vidmate.net/get_palcomp3.php?url=" + encodeURIComponent(url);
	try {
		vid_mate_setParseMsg(20, 60, 'Get Video Info...  ...');

		var referer = global_document_url;
		var cookie = "";
		if(window.vbrowser.httpGetCookie)
		{
			cookie = window.vbrowser.httpGetCookie(global_document_url);
		}
		else
		{
			cookie = document.cookie;
		}

		var userAgent = "Mozilla/5.0 (Linux; Android 4.3; Build/KRT16M) AppleWebKit/517.36 (KHTML, like Gecko) Version/4.0 Chrome/30.0.0.0 Mobile Safari/537.36";
		var method = "POST";
		var data = "";
		vid_mate_app_xhr_adv(url, referer, cookie, userAgent, method, data);
	} catch (e) {
		vid_mate_error_default('vuclip 1');
		return null;
	}
}

function vid_mate_video_analytics(vm_content)
{
	if(!vm_content)
	{
		vid_mate_error_default('vm_content is empty');
		return null;
	}

	var data = eval('('+vm_content+')');

	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "palcomp3";
	rtn_video.id = vid_mate_get_video_id(global_document_url) + parseInt(Math.random()*1000000);

	rtn_video.title = vid_mate_get_video_id(global_document_url);
	for(var i=0; i<data.musicas.length; ++i)
	{
		var obj = data['musicas'][i];
		if(0 == i)
		{
			var img = obj.artista.logo;
			rtn_video.picture_default = img;
			rtn_video.picture_big = img;
		}
		var videoUrl = obj.mp3;
		var title = obj.nome;

		var tmp_video_file = new vid_mate_video_file();
		tmp_video_file.url = videoUrl;
		var tmp_format = vid_mate_get_video_format(tmp_video_file.url);
		tmp_video_file.format = tmp_format;
		tmp_video_file.title = title;
		tmp_video_file.ext = title;
		tmp_video_file.f_id = rtn_video.id+"_"+title;
		rtn_video.files.push(tmp_video_file);
	}

	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(rtn_video));
}

function vid_mate_get_video_info_on_blank(url)
{
	vid_mate_get_video_info(url);
}
