var global_rtn_video = global_rtn_video || null;
var global_document_url = global_document_url || null;
var global_offset = 0;
var global_downlaod_url = null;

function vid_mate_get_video_id(url)
{
	var vid_mate_url = url || document.URL;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}

	if(-1 == vid_mate_url.indexOf("uyeshare"))
	{
		return null;
	}

	var video_id = null;
	if(-1 != vid_mate_url.indexOf("site_index-of-mp3-detile.xhtml"))
	{
		video_id = vid_mate_get_parameter(vid_mate_url, "cmid");
	}
	else if(-1 != vid_mate_url.indexOf("site_file_detile.xhtml"))
	{
		video_id = vid_mate_get_parameter(vid_mate_url, "get-id");
	}

	return video_id;
}

function vid_mate_check() {
	if (vid_mate_get_video_id() == null) {
		vid_mate_set_canDownload(false);
		return false;
	} else {
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_get_video_info(url)
{
    vid_mate_setParseMsg(10, 20, 'Start Analytics');

	var vid_mate_video_id = vid_mate_get_video_id(url);
	vid_mate_setParseMsg(20, 60, 'Get Video Info');

	global_document_url = url;
	try {
		vid_mate_setParseMsg(20, 60, 'Get Video Info......');

		var referer = url;
		var cookie = "";
		if(window.vbrowser.httpGetCookie)
		{
			cookie = window.vbrowser.httpGetCookie(global_document_url);
		}
		else
		{
			cookie = document.cookie;
		}

		var userAgent = "Mozilla/5.0 (Linux; Android 4.3; Build/KRT16M) AppleWebKit/517.36 (KHTML, like Gecko) Version/4.0 Chrome/30.0.0.0 Mobile Safari/537.36";
		//var userAgent = navigator.userAgent;
		var method = "get";
		var data = "";
		vid_mate_app_xhr_adv(url, referer, cookie, userAgent, method, data);
	} catch (e) {
		vid_mate_error_default('uyeshare 1');
		return null;
	}
}

function vid_mate_video_analytics(vm_content)
{
	if(!vm_content)
	{
		vid_mate_error_default('vm_content is empty');
		return null;
	}

	var videoUrl = "";
	var videoImg = "";
	var videoTitle = "";

	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "uyeshare";
	rtn_video.id = vid_mate_get_video_id(global_document_url);
	
	if(-1 != global_document_url.indexOf("uyeshare"))
	{
		if(global_document_url)
		{
			var mp3_url = "";
			if(-1 != global_document_url.indexOf("site_index-of-mp3-detile.xhtml"))
			{
				mp3_url = cutstr(vm_content, "href=\"/music", "\"");
				if(mp3_url)
				{
					mp3_url = "http://www.uyeshare.com/music" + mp3_url;
				}
				else
				{
					vid_mate_error_default('site_index-of-mp3-detile no mp3 url');
					return null;
				}
			}
			else if(-1 != global_document_url.indexOf("site_file_detile.xhtml"))
			{
				mp3_url = cutstr(vm_content, "source src=\"", "\"");
				if(mp3_url)
				{
					mp3_url = "http://www.uyeshare.com/" + mp3_url;
				}
				else
				{
					vid_mate_error_default('site_file_detile no mp3 url');
					return null;
				}
			}
			
			if(!mp3_url)
			{
			   vid_mate_error_default('can not find video');
			   return null;
			}
				
			global_downlaod_url = mp3_url;
			rtn_video.picture_default = videoImg;
			rtn_video.picture_big = videoImg;
			
			var arr_title = global_downlaod_url.split("/");
			if(arr_title.length <= 3)
			{
				videoTitle = "uyeshare download mp3";
			}
			
			var len = arr_title.length;
			videoTitle = arr_title[len-1];
			if(!videoTitle)
			{
			  videoTitle = "uyeshare download mp3";
			}
			
			rtn_video.title = videoTitle;	
	        global_rtn_video = rtn_video;
			//302 handler
			try {
					window.vbrowser.httpBeginGetAll();
					var url = "http://api.apk.vidmate.net/url?url=" + mp3_url;
					window.vbrowser.httpAddUrl(url);
					window.vbrowser.httpGetAll('vid_mate_app_xhr_more_result()');
			}
			catch (e) {
					vid_mate_error_default('uyeshare 302 request ' + e.name + ": " + e.message);
					return null;
			}
		
		}
	}
	else
	{
	   vid_mate_error_default('can not find video');
	   return null;
	}

}

function vid_mate_app_xhr_more_result() {
        var rtn_contents = [];
        try {
                var tmp_count = window.vbrowser.httpGetResCount();
                for (var i = 0;i < tmp_count;i ++) 
				{
                        var tmp_content = window.vbrowser.httpGetResAtIndex(i);
                        rtn_contents.push(tmp_content);
				}
			} catch (e) 
			{
					vid_mate_error_default('uyeshare 3\r\n' + e.name + ": " + e.message);
					return null;
			}

        vid_mate_video_analytics_more(rtn_contents);
}


function vid_mate_video_analytics_more(vm_content_array)
{
        for(var i=0; i<vm_content_array.length; ++i)
        {
                var videoUrl = vm_content_array[i];
                if(!videoUrl)
                {
                    continue;
                }
				
                videoUrl = decodeURIComponent(videoUrl);
                videoUrl = videoUrl.replace(/&amp;/g, "&");
                videoUrl = videoUrl.replace(/ /g, "%20");
                var tmp_video_file = new vid_mate_video_file();
                tmp_video_file.url = videoUrl;
                var tmp_format = vid_mate_get_video_format(tmp_video_file.url);
                tmp_video_file.format = tmp_format;
                tmp_video_file.title = tmp_format;
                tmp_video_file.f_id = global_rtn_video.id + "_"+ tmp_format;
                global_rtn_video.files.push(tmp_video_file);
        }

        if(0 == global_rtn_video.files.length)
        {
		     vid_mate_error_default('uyeshare length is 0');
             return null;
        }

        vid_mate_setParseMsg(100, 100, 'Completed');
        vid_mate_set_videoInfo(JSON.stringify(global_rtn_video));
}



function vid_mate_get_video_info_on_blank(url)
{
	vid_mate_get_video_info(url);
}

function rcutstr(content, prefix, suffix)
{
	var prefix_len = prefix.length;
	var p2 = content.indexOf(suffix);
	if(-1 == p2)
	{
		return "";
	}

	content = content.substr(0, p2);

	var p1 = content.lastIndexOf(prefix);
	if(-1 == p2)
	{
		return "";
	}
	return content.substring(p1 + prefix_len , p2);
}

function get_pathname(url)
{
	var arr = url.split("?");
	url = arr[0];
	arr = url.split("/");
	arr.pop();
	var pathname = "";
	var sep = "/";
	for(var i=3; i<arr.length; ++i)
	{
		pathname += sep + arr[i];
	}
	if(0 == pathname.length)
	{
		pathname = "/";
	}
	return pathname;
}

function cutstr(content, prefix, suffix)
{
	var prefix_len = prefix.length;
	var p1 = content.indexOf(prefix);
	if(-1 == p1)
	{
		return "";
	}
	p1 += prefix_len;
	var p2 = content.indexOf(suffix, p1);
	if(-1 == p2)
	{
		return "";
	}
	return content.substring(p1, p2);
}
