var global_rtn_video = global_rtn_video || null;
var global_document_url = global_document_url || null;

function vid_mate_get_video_id(url) {
	var vid_mate_url = url || document.URL;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}
	//http://mastimobile.com/filedownload/575/13991/Sylvia%20(Bombay%20Velvet).html
	if(-1 == vid_mate_url.indexOf("mastimobile"))
	{
		return null;
	}
	var tmp_re = new RegExp("/filedownload/([0-9]+)/([0-9]+)/(.+?)\.html$");
	if (tmp_re.test(vid_mate_url)) {
		var tmp_m = vid_mate_url.match(tmp_re);
		return tmp_m[2];
	}
	return null;
}

function vid_mate_check() {
	if (vid_mate_get_video_id() == null) {
		vid_mate_set_canDownload(false);
		return false;
	} else {
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_get_video_info(url)
{
    vid_mate_setParseMsg(10, 20, 'Start Analytics');

	var vid_mate_video_id = vid_mate_get_video_id(url);
	vid_mate_setParseMsg(20, 60, 'Get Video Info');

	global_document_url = url;

	try {
		vid_mate_setParseMsg(20, 60, 'Get Video Info......');

		var referer = url;
		var cookie = "";
		if(window.vbrowser.httpGetCookie)
		{
			cookie = window.vbrowser.httpGetCookie(global_document_url);
		}
		else
		{
			cookie = document.cookie;
		}

		var userAgent = "Mozilla/5.0 (Linux; Android 4.3; Build/KRT16M) AppleWebKit/517.36 (KHTML, like Gecko) Version/4.0 Chrome/30.0.0.0 Mobile Safari/537.36";
		//var userAgent = navigator.userAgent;
		var method = "get";
		var data = "";
		vid_mate_app_xhr_adv(url, referer, cookie, userAgent, method, data);
	} catch (e) {
		vid_mate_error_default('mastimobile 1');
		return null;
	}
}

function vid_mate_video_analytics(vm_content)
{
	if(!vm_content)
	{
		vid_mate_error_default('vm_content is empty');
		return null;
	}

	var videoUrl = "";

	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "mastimobile";
	rtn_video.id = vid_mate_get_video_id(global_document_url);

	//http://mastimobile.com/files/download/id/13991/Sylvia%20(Bombay%20Velvet).html
	//var videoUrl = "http://mastimobile.com/files/download/id/"+rtn_video.id+"/"+rtn_video.id+".html";

	var videoUrl = rcutstr(vm_content, "href=\"", "\">[Download");
	if(!videoUrl)
	{
		vid_mate_error_default('get video url fail');
		return null;
	}

	var videoImg = rcutstr(vm_content, "\"", "\" width=\"\" height=\"\"");
	if(videoImg)
	{
		rtn_video.picture_default = videoImg;
		rtn_video.picture_big = videoImg;
	}

	//title
	rtn_video.title = "";
	var title = "";
	var tmp_format = "mp4";

	var tmp_re = new RegExp("Free Download (.+?)</h2>");
	if (tmp_re.test(vm_content))
	{
		var tmp_m = vm_content.match(tmp_re);
		title = tmp_m[1];
		title = title.trim();
		title = title.replace("Free Download", "");
		title = title.trim();
		var arr = title.split(".");
		tmp_format = arr.pop();
		title = arr.join(".");
		rtn_video.title = title;
	}

	var tmp_video_file = new vid_mate_video_file();
	tmp_video_file.url = videoUrl;
	tmp_video_file.format = tmp_format;
	tmp_video_file.title = tmp_format;
	tmp_video_file.f_id = rtn_video.id+"_mp4";
	rtn_video.files.push(tmp_video_file);

	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(rtn_video));

}

function vid_mate_get_video_info_on_blank(url)
{
	vid_mate_get_video_info(url);
}

function rcutstr(content, prefix, suffix)
{
	var prefix_len = prefix.length;
	var p2 = content.indexOf(suffix);
	if(-1 == p2)
	{
		return "";
	}

	content = content.substr(0, p2);

	var p1 = content.lastIndexOf(prefix);
	if(-1 == p2)
	{
		return "";
	}
	return content.substring(p1 + prefix_len , p2);
}

