var global_vid_mate_video_id = "";
var global_document_url = "";
var global_rtn_video = {};

function vid_mate_get_video_id(url) {
	var vid_mate_url = url || document.URL;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}
	var tmp_re = new RegExp("/(showmovie.php|gotodownload.php)\\?id=([0-9]+)(.*)");
	if (tmp_re.test(vid_mate_url)) {
		var tmp_m = vid_mate_url.match(tmp_re);
		return tmp_m[2];
	}
	var tmp_re = new RegExp("/download([0-9]+).php\\?id=([0-9]+)(.*)");
	if (tmp_re.test(vid_mate_url)) {
		var tmp_m = vid_mate_url.match(tmp_re);
		return tmp_m[2];
	}
	return null;
}

function vid_mate_check(url) {
    if (vid_mate_get_video_id(url) == null) {
        vid_mate_set_canDownload(false);
		return false;
	} else {
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_mp4movies_v_1() {
	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "pinguda";
	rtn_video.id = vid_mate_get_video_id();
	var tmp_metas = document.getElementsByTagName('meta');
	for (var i = 0;i < tmp_metas.length;i ++) {
		var tmp_property = tmp_metas[i].getAttribute('property');
		var tmp_content = tmp_metas[i].getAttribute('content');
		if (tmp_property == 'og:title') {
			rtn_video.title = tmp_content;
		} else if (tmp_property == 'og:url') {
			rtn_video.url = tmp_content;
		} else if (tmp_property == 'og:image') {
			rtn_video.picture_default = tmp_content;
			rtn_video.picture_big = tmp_content;
		}
	}
	if (rtn_video.title == '') {
		return null;
	}
	return rtn_video;
}

function vid_mate_mp4movies_v_3(vm_content) {
	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "pinguda";
	rtn_video.id = global_vid_mate_video_id;
	var tmp_re = new RegExp('<meta property="og:title" content="([^"]+)" />');
	if (!tmp_re.test(vm_content)) {
		return null;
	}
	var tmp_m = vm_content.match(tmp_re);
	rtn_video.title = tmp_m[1];
	var tmp_re = new RegExp('<meta property="og:url" content="([^"]+)" />');
	if (!tmp_re.test(vm_content)) {
		rtn_video.url = global_document_url;
	} else {
		var tmp_m = vm_content.match(tmp_re);
		rtn_video.url = tmp_m[1];
	}
	var tmp_re = new RegExp('<meta property="og:image" content="([^"]+)" />');
	if (tmp_re.test(vm_content)) {
		var tmp_m = vm_content.match(tmp_re);
		rtn_video.picture_default = tmp_m[1];
		rtn_video.picture_big = tmp_m[1];
	}
	return rtn_video;
}

function vid_mate_mp4movies_v_f_find(f,fs) {
	for (var i = 0;i < fs.length;i ++) {
		if (f.url == fs[i].url) {
			return true;
		}
	}
	return false;
}

function vid_mate_mp4movies_v_f_1(rtn_contents) {
	var tmp_video_files = [];

	for (var i = 0;i < rtn_contents.length;i ++) {
		var tmp_re = new RegExp("<a href=\"http://download([0-9]+)([^\"]+)\"><b>Click Here To Download Part ([0-9]+) \\(Automatically From Best Server\\)</b></a>");
		rtn_contents[i] = rtn_contents[i].replace(" onclick=\"analytics();\"","");
		if (tmp_re.test(rtn_contents[i])) {
			var tmp_m = rtn_contents[i].match(tmp_re);
			var tmp_video_file = new vid_mate_video_file();
			tmp_video_file.f_id = global_vid_mate_video_id + '_' + tmp_m[3] + '_' + tmp_m[1];
			tmp_video_file.url = 'http://download' + tmp_m[1] + decodeURIComponent(tmp_m[2]);
			var tmp_format = vid_mate_get_video_format(tmp_video_file.url);
			tmp_video_file.format = tmp_format;
			tmp_video_file.title = tmp_format + '(Part ' + tmp_m[3] + ' Server ' + tmp_m[1] + ')';
			tmp_video_files.push(tmp_video_file);
		}
	}

	if (tmp_video_files.length <= 0) {
		return null;
	}
	return tmp_video_files;
}

function vid_mate_mp4movies_v_f_3(vm_content) {
	var tmp_re = new RegExp("<a href=\"http://download([0-9]+)([^\"]+)\"([^>]*)><b>Click Here To Download Part ([0-9]+) \\(Automatically From Best Server\\)</b></a>");
	if (!tmp_re.test(vm_content)) {
		return false;
	}
	var tmp_video_files = [];
	var tmp_m = vm_content.match(tmp_re);
	var tmp_video_file = new vid_mate_video_file();
	tmp_video_file.f_id = vid_mate_get_video_id() + '_' + tmp_m[4] + '_' + tmp_m[1];
	tmp_video_file.url = 'http://download' + tmp_m[1] + decodeURIComponent(tmp_m[2]);
	var tmp_format = vid_mate_get_video_format(tmp_video_file.url);
	tmp_video_file.format = tmp_format;
	tmp_video_file.title = tmp_format + '(Part ' + tmp_m[4] + ' Server ' + tmp_m[1] + ')';
	tmp_video_files.push(tmp_video_file);
	return tmp_video_files;
}

function vid_mate_video_analytics_more(rtn_contents) {
	vid_mate_setParseMsg(60, 90, 'Analytics Video Info');

	if (document.location.pathname == '/gotodownload.php') {
		var rtn_video = vid_mate_mp4movies_v_3(rtn_contents[0]);
		var tmp_video_files = vid_mate_mp4movies_v_f_3(rtn_contents[1]);
		if (rtn_video == null || tmp_video_files == null) {
			vid_mate_error_default('pinguda 1');
			return null;
		}
		for (var i = 0;i < tmp_video_files.length;i ++) {
			rtn_video.files.push(tmp_video_files[i]);
		}
	} else {
		var rtn_video = vid_mate_mp4movies_v_1();
		var tmp_video_files = vid_mate_mp4movies_v_f_1(rtn_contents);
		if (rtn_video == null || tmp_video_files == null) {
			vid_mate_error_default('pinguda 2');
			return null;
		}
		for (var i = 0;i < tmp_video_files.length;i ++) {
			rtn_video.files.push(tmp_video_files[i]);
		}
	}
	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(rtn_video));
}

function vid_mate_app_xhr_more_result() {
	var rtn_contents = [];
	try {
		var tmp_count = window.vbrowser.httpGetResCount();
		for (var i = 0;i < tmp_count;i ++) {
			var tmp_content = window.vbrowser.httpGetResAtIndex(i);
			rtn_contents.push(tmp_content);
		}
	} catch (e) {
		vid_mate_error_default('pinguda 3\r\n' + e.name + ": " + e.message);
	}

	vid_mate_video_analytics_more(rtn_contents);
}

function vid_mate_app_xhr_more(urls) {
    try {
		window.vbrowser.httpBeginGetAll();
		for (var i = 0;i < urls.length;i ++) {
			window.vbrowser.httpAddUrl(urls[i]);
		}
		window.vbrowser.httpGetAll('vid_mate_app_xhr_more_result()');
    } catch (e) {
		vid_mate_error_default('pinguda 4\r\n' + e.name + ": " + e.message);
	}
}

function vid_mate_video_analytics(vm_content) {
    vid_mate_setParseMsg(60, 90, 'Analytics Video Info');

	var rtn_video = vid_mate_mp4movies_v_3(vm_content);
	var tmp_video_files = vid_mate_mp4movies_v_f_3(document.body.innerHTML);
	if (rtn_video == null || tmp_video_files == null) {
		vid_mate_error_default('pinguda 5');
		return null;
	}
	for (var i = 0;i < tmp_video_files.length;i ++) {
		rtn_video.files.push(tmp_video_files[i]);
	}

	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(rtn_video));
}

function vid_mate_get_video_info(url) {
	if(null == url || undefined == url || 0 == url.length)
	{
		return vid_mate_get_video_info_on_blank(document.URL);
	}
    vid_mate_setParseMsg(10, 20, 'Start Analytics');

	/*
	if (!vid_mate_check()) {
		return null;
	}
	*/

	var vid_mate_video_id = vid_mate_get_video_id();
	if(null == vid_mate_video_id)
	{
		return null;
	}
	global_vid_mate_video_id = vid_mate_video_id;
	global_document_url = url;

	vid_mate_setParseMsg(20, 60, 'Get Video Info');
	if (document.location.pathname == '/showmovie.php') {
		try {
			var tmp_urls = [];
			var tmp_re = new RegExp('</center>');
			var tmp_content = document.body.innerHTML;
			var tmp_arr = tmp_content.split(tmp_re);
			for (var i = 0;i < tmp_arr.length;i ++) {
				var tmp_re = new RegExp("<a href=\"gotodownload.php\\?id=([0-9]+)&amp;part=([0-9]+)\">(.*)Click Here To Download Part ([0-9]+)(.*)</a>");

				if (tmp_re.test(tmp_arr[i])) {
					var tmp_m = tmp_arr[i].match(tmp_re);
					var tmp_url = 'http://' + document.location.hostname + '/download' + tmp_m[2] + '.php?id=' + tmp_m[1];
					tmp_urls.push(tmp_url);
				}
			}
			if (tmp_urls.length <= 0) {
				vid_mate_error_default('pinguda 6');
				return null;
			}
			vid_mate_app_xhr_more(tmp_urls);
		} catch (e) {
			vid_mate_error_default('pinguda 7\r\n' + e.name + ": " + e.message);
			return null;
		}
	} else if (document.location.pathname == '/gotodownload.php') {
		try {
			var tmp_urls = [];
			var vid_mate_url_get = 'http://' + document.location.hostname + '/showmovie.php?id=' + vid_mate_video_id;
			tmp_urls.push(vid_mate_url_get);
			var tmp_re = new RegExp('<a href="download([0-9]+).php\\?id=([0-9]+)"><b>Click Here To Go To Download Page</b></a>');
			var tmp_content = document.body.innerHTML;
			if (!tmp_re.test(tmp_content)) {
				vid_mate_error_default('pinguda 8');
				return null;
			}
			var tmp_m = tmp_content.match(tmp_re);
			tmp_urls.push('http://' + document.location.hostname + '/download' + tmp_m[1] + '.php?id=' + tmp_m[2]);
			vid_mate_app_xhr_more(tmp_urls);
		} catch (e) {
			vid_mate_error_default('pinguda 9\r\n' + e.name + ": " + e.message);
			return null;
		}
	} else {
		try {
			var vid_mate_url_get = 'http://' + document.location.hostname + '/showmovie.php?id=' + vid_mate_video_id;
			vid_mate_app_xhr(vid_mate_url_get);
		} catch (e) {
			vid_mate_error_default('pinguda 10\r\n' + e.name + ": " + e.message);
			return null;
		}
	}
}

//for blank
function vid_mate_get_video_info_on_blank(url)
{
	var vid_mate_video_id = vid_mate_get_video_id(url);
	if(null == vid_mate_video_id)
	{
		return false;
	}
	global_vid_mate_video_id = vid_mate_video_id;
	global_document_url = url;

    vid_mate_setParseMsg(10, 60, 'Start Get Video Info.....');
	var hostname = get_hostname(url);
	var vid_mate_url_get = 'http://' + hostname + '/showmovie.php?id=' + vid_mate_video_id;
    try
	{
        window.vbrowser.httpReq(vid_mate_url_get, 'vid_mate_app_xhr_result_for_blank()');
    }
	catch (e)
	{
		vid_mate_error(vid_mate_error_msg, e.name + ": " + e.message);
	}
}

function vid_mate_app_xhr_result_for_blank()
{
	var vid_mate_response;
	try
	{
		vid_mate_response = window.vbrowser.getHttpRes();
	}
	catch (e)
	{
		vid_mate_error(vid_mate_error_msg, e.name + ": " + e.message);
	}

	if (vid_mate_response != null && vid_mate_response.length > 0)
	{
		vid_mate_video_analytics_for_blank(vid_mate_response);
	}
}


function vid_mate_video_analytics_for_blank(document_content)
{
	var vid_mate_video_id = global_vid_mate_video_id;
	global_rtn_video = vid_mate_mp4movies_v_3(document_content);
	global_rtn_video.id = vid_mate_video_id;

	var hostname = get_hostname(global_document_url);

	try {
		var tmp_urls = [];
		var tmp_re = new RegExp('</center>');
		var tmp_content = document_content;
		var tmp_arr = tmp_content.split(tmp_re);
		for (var i = 0;i < tmp_arr.length;i ++)
		{
			var tmp_re = new RegExp("<a href=\"gotodownload.php\\?id=([0-9]+)&amp;part=([0-9]+)\">(.*)Click Here To Download Part ([0-9]+)(.*)</a>");
			if (tmp_re.test(tmp_arr[i])) {
				var tmp_m = tmp_arr[i].match(tmp_re);
				var tmp_url = 'http://' + hostname + '/download' + tmp_m[2] + '.php?id=' + tmp_m[1];
				tmp_urls.push(tmp_url);
			}
		}
		if (tmp_urls.length <= 0)
		{
			vid_mate_error_default('pinguda 6');
			return null;
		}

		try
		{
			window.vbrowser.httpBeginGetAll();
			for (var i = 0;i < tmp_urls.length;i ++)
			{
				window.vbrowser.httpAddUrl(tmp_urls[i]);
			}

			window.vbrowser.httpGetAll('vid_mate_app_xhr_more_result_for_blank()');
		}
		catch (e) {
			vid_mate_error_default('pinguda 4\r\n' + e.name + ": " + e.message);
		}
	}
	catch (e)
	{
		vid_mate_error_default('pinguda 7\r\n' + e.name + ": " + e.message);
		return null;
	}
}

function vid_mate_app_xhr_more_result_for_blank()
{
	var rtn_contents = [];
	try {
		var tmp_count = window.vbrowser.httpGetResCount();
		for (var i = 0;i < tmp_count;i ++) {
			var tmp_content = window.vbrowser.httpGetResAtIndex(i);
			rtn_contents.push(tmp_content);
		}
	} catch (e) {
		vid_mate_error_default('pinguda 3\r\n' + e.name + ": " + e.message);
	}

	vid_mate_video_analytics_more_for_blank(rtn_contents);
}

function vid_mate_video_analytics_more_for_blank(rtn_contents)
{
	vid_mate_setParseMsg(60, 90, 'Analytics Video Info...');

	var rtn_video = global_rtn_video;
	var tmp_video_files = vid_mate_mp4movies_v_f_1(rtn_contents);
	if (rtn_video == null || tmp_video_files == null) {
		vid_mate_error_default('pinguda 2');
		return null;
	}

	for (var i = 0;i < tmp_video_files.length;i ++)
	{
		rtn_video.files.push(tmp_video_files[i]);
	}

	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(rtn_video));
}

function get_hostname(url)
{
	var arr = url.split("/");
	return arr[2];
}